﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RFClassGraphExt
{
    public partial class MainWindow : Window
    {
        DockPanel Panel = new DockPanel();

        public MainWindow()
        {
            InitializeComponent();
            this.Content = Panel;
            Loaded += OnLoaded;
        }

        public void AddEdge(string source, string target)
        {
            graph.AddEdge(source, target);
            graphViewer.Graph = graph;
        }

        public bool FindEdge(string source, string target)
        {
            foreach (var i in graph.Edges)
            {
                if (i.Source == source && i.Target == target)
                    return true;
            }
            return false;
        }

        public void Clear()
        {
            ResetGraph();
        }

        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            try
            {
                graphViewer = new Microsoft.Msagl.WpfGraphControl.GraphViewer();
                graphViewer.BindToPanel(Panel);
                ResetGraph();
            }
            catch (System.Exception ex)
            {
                System.Windows.MessageBox.Show(ex.ToString());
            }
        }

        private void ResetGraph()
        {
            graph = new Microsoft.Msagl.Drawing.Graph();
            graph.Attr.LayerDirection = Microsoft.Msagl.Drawing.LayerDirection.LR;
            graphViewer.Graph = graph;
        }

        private Microsoft.Msagl.WpfGraphControl.GraphViewer graphViewer;
        private Microsoft.Msagl.Drawing.Graph graph;
    }
}
