﻿namespace RFClassGraphExt
{
    class SatelliteAssembliesResolver
    {
        public SatelliteAssembliesResolver()
        {
            System.AppDomain.CurrentDomain.AssemblyResolve += OnResolve;
        }

        public void Close()
        {
            System.AppDomain.CurrentDomain.AssemblyResolve -= OnResolve;
        }

        private System.Reflection.Assembly OnResolve(object sender, System.ResolveEventArgs args)
        {
            try
            {
                if (args.Name.StartsWith("Microsoft.Msagl.WpfGraphControl,", System.StringComparison.CurrentCultureIgnoreCase))
                    return Resolve(@"msagl\Microsoft.Msagl.WpfGraphControl");
                if (args.Name.StartsWith("Microsoft.Msagl.Drawing,", System.StringComparison.CurrentCultureIgnoreCase))
                    return Resolve(@"msagl\Microsoft.Msagl.Drawing");
                if (args.Name.StartsWith("Microsoft.Msagl,", System.StringComparison.CurrentCultureIgnoreCase))
                    return Resolve(@"msagl\Microsoft.Msagl");
            }
            catch (System.Exception e)
            {
                System.Windows.MessageBox.Show(e.ToString());
            }
            return null;
        }

        private static System.Reflection.Assembly Resolve(string name)
        {
            return System.Reflection.Assembly.LoadFrom(System.IO.Path.Combine(
                System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location),
                name + ".dll"));
        }
    }
}
